/* **************************************************
   get_str procedure ver 1.01
     This version is ANSI C standard.
   control keys:
    ALPHA  - switches between alpha and numeric mode
    SHIFT  - when in alpha mode switches between
             upper and lower case
    LEFT ARROW, DEL - works as backspace
    EXE,F6 - enter key, F6 is because PC tests

    I'm waiting for any sugestions of improvements,
    contact:Jarek Wosik (Roeoender)
            drzodrzo@kki.net.pl
    use:
      your program must contain lines:
      #include <stdio.h>
      #include <conio.h>
      #include "get_str.cpp"
      both get_str.cpp and keyb.cpp must be in
      current directory.

    Example:
      char string [10];
      get_str (string,10,LOCASE_MODE);
                 ^     ^    ^-initial modes, can be:
                 |     |        ALPHA_MODE
                 |     |        LOCASE_MODE
                 |     |        NUM_MODE
                 |     +------size of string
                 +------------char *
   ************************************************** */



/* F6 (64) is uncommented works as enter key for PC*/
#include "keyb.c"  /*list of keys*/
#define ALPHA_MODE 0 /*for InitMode*/
#define LOCASE_MODE 1 /*lower case mode*/
#define NUM_MODE 2   /*numeric mode*/
#define ALPHA_DIST 32/*distance between low and upper case in ASCII table*/

/*Prototype:*/
void get_str (char *str ,int size, char mode);

void get_str (char *str ,int size, char mode) {
  int index=0;
  char key;
  char DnCase=0;/* may be 0 (up) or ALPHA_DIST (low) */
  char ndone=1;

  if (mode==LOCASE_MODE) {
    DnCase=ALPHA_DIST;/*so it's now lower case*/
    mode=ALPHA_MODE;
  }
/*!!! here may be a buffer clear flush buff or something*/
  while ((index<size)&&(ndone)) {
    key = getch ();
    if (key == 0) {
      key = getch ();
      switch (key) {
/*        case 60://comment this for casio*/
        case ALPHA_EK:  /*change mode between alpa and num*/
               if (mode==ALPHA_MODE) mode=NUM_MODE;
	       else mode=ALPHA_MODE;
        break;
/*        case 61://comment this for casio*/
        case SHIFT_EK:  /*if alpha mode then change between upper case and lower case*/
               if (mode==ALPHA_MODE)
	       if (DnCase==ALPHA_DIST) DnCase=0;
               else DnCase=ALPHA_DIST;
        break;
	case DEL_EK:
	case LEFT_EK: if (index>0) {/* both keys act like backspace */
			 index--;
			 putchar (8);
			 putchar (' ');
			 putchar (8);
		      }; break;
	case 64:/* comment this for casio F6 */
        case EXE_EK: ndone=0; puts (""); break;/* casio change*/
      }/*switch for extended keys end*/
    }/*if for extended key check end*/
    else {/*non extended keys*/
      switch (key) {/*ordinary alpha*/
	case 'A': case 'B': case 'C': case 'D': case 'E':
	case 'F': case 'G': case 'H': case 'I': case 'J':
	case 'K': case 'L': case 'S': case 'T': case 'X': case 'Y':
	  if (mode==ALPHA_MODE) {
            key+=DnCase;
	    putchar (key); str [index]=key; index++;
          }
        break;
        case DOT_K:
          if (mode==ALPHA_MODE) key=' ';/* in alpha mode coma acts like space */
          putchar (key); str [index]=key; index++;
	break;
      }/* switch standart alpha */
      if (mode==ALPHA_MODE)
        switch (key) {
    	  case '0':key='Z'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '1':key='U'; key+=DnCase; putchar (key); str [index]=key; index++; break;
  	  case '2':key='V'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '3':key='W'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '4':key='P'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '5':key='Q'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '6':key='R'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '7':key='M'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '8':key='N'; key+=DnCase; putchar (key); str [index]=key; index++; break;
	  case '9':key='O'; key+=DnCase; putchar (key); str [index]=key; index++; break;
      } else/* switch numeric if alpha num */
      {
        if (key>='0'&&key<='9') {
          putchar (key); str [index]=key; index++;
        }
      }
    }/* non extended */
  };/* while */
  if (ndone) puts ("");
  str [index]=0;/* mark end of text */
}
